package com.bwie;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * &#064;Author:  wangxinyuan
 * &#064;Date:  2024/8/8 上午8:37
 */
public class Test {
    public static void main(String[] args) {

        // 创建5名学生对象
        List<Student> students = new ArrayList<>();
        students.add(new Student(1, "张三", "语文", 100.65));
        students.add(new Student(2, "李四", "数学", 94.47));
        students.add(new Student(3, "王五", "英语", 78.77));
        students.add(new Student(4, "赵六", "化学", 82.43));
        students.add(new Student(5, "田七", "科学", 69.24));

        //将所有学生拼接字符串放入集合中,如：1,张三,语文,100  2,张三,数学,90。
        List<String> studentStrings = students.stream()
                .map(student -> String.format("%d,%s,%s,%.2f", student.getId(),
                        student.getName(), student.getSubject(),
                        student.getScore()))
                .toList();


        // 使用stream操作集合并输出每个人的名字及其平均成绩
        students.stream()
                .collect(Collectors.groupingBy(Student::getName,
                        Collectors.averagingDouble(Student::getScore)))
                .forEach((name, avgScore) -> System.out.println(name + " 的平均成绩为: " + avgScore));

        // 输出所有学生的拼接字符串
        studentStrings.forEach(System.out::println);


    }
}
